## dynare 7~beta1

=== macOS/Makefile ===
# Copyright © 2019-2025 Dynare Team
#
# This file is part of Dynare.
#
# Dynare is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Dynare is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

ARCHS = arm64 x86_64
BUILDS = $(addprefix build-, $(ARCHS))
DEPS = $(addprefix deps-, $(ARCHS))
CLEAN_DEPS = $(addprefix clean-deps-, $(ARCHS))
CLEAN_DEPS_ALL = $(addprefix clean-deps-all-, $(ARCHS))

.PHONY: build $(BUILDS) $(DEPS) $(CLEAN_DEPS) $(CLEAN_DEPS_ALL) clean-pkgs clean clean-all

build: $(BUILDS)

$(BUILDS): build-%: deps-%
	./build.sh $*

$(DEPS): deps-%:
	gmake -C deps PKG_ARCH=$*

$(CLEAN_DEPS): clean-deps-%:
	gmake -C deps clean PKG_ARCH=$*

$(CLEAN_DEPS_ALL): clean-deps-all-%:
	gmake -C deps clean-all PKG_ARCH=$*

clean-pkgs:
	rm -rf pkg

# Clean everything except downloaded tarballs of dependencies
clean: clean-pkgs $(CLEAN_DEPS)

# Clean everything (including downloaded tarballs of dependencies)
clean-all: clean-pkgs $(CLEAN_DEPS_ALL)

=== macOS/deps/Makefile ===
# Copyright © 2019-2026 Dynare Team
#
# This file is part of Dynare.
#
# Dynare is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Dynare is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

include versions.mk

# settings for different architectures
PKG_ARCH ?= x86_64 # use x86_64 by default

BREWDIR := $(if $(filter arm64,$(PKG_ARCH)),/opt/homebrew,/usr/local)

ROOT_PATH = $(realpath .)

WGET_OPTIONS := --no-verbose --no-use-server-timestamps --retry-connrefused --retry-on-host-error

NTHREADS=$(shell sysctl -n hw.perflevel0.physicalcpu)

.PHONY: all clean clean-all

all: $(PKG_ARCH)/src/slicot-matlab/build/lib/libslicot64_pic.a $(PKG_ARCH)/src/x13as/x13as $(PKG_ARCH)/panua-pardiso $(PKG_ARCH)/src/suitesparse

# Clean everything except downloaded tarballs
clean:
	rm -rf $(PKG_ARCH)/src $(PKG_ARCH)/panua-pardiso

# Clean everything (including downloaded tarballs)
clean-all: clean
	rm -rf tarballs

#
# Slicot
#

tarballs/slicot-$(SLICOT_VERSION).tar.gz:
	mkdir -p $(dir $@)
	wget $(WGET_OPTIONS) -O $@ https://github.com/SLICOT/SLICOT-Reference/archive/refs/tags/v$(SLICOT_VERSION).tar.gz

$(PKG_ARCH)/src/slicot-matlab/build/lib/libslicot64_pic.a: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf $(realpath $(dir $@)/../..)
	mkdir -p $(dir $@)/../..
	tar xf $< --directory $(dir $@)/../.. --strip-components=1
	patch -d $(dir $@)/../.. -p1 < ../../windows/deps/slicot-no-blas-lapack-lookup.patch
	cmake -S $(dir $@)/../.. -B $(dir $@)/.. -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=OFF -DSLICOT_TESTING=OFF -DSLICOT_INTEGER8=ON
	cmake --build $(dir $@)/.. --verbose
	mv $(dir $@)/libslicot64.a $@


#
# X13AS
#

tarballs/x13as_asciisrc-v$(X13AS_VERSION).tar.gz:
	mkdir -p $(dir $@)
	wget $(WGET_OPTIONS) -O $@ https://www.dynare.org/pkg-build/x13as/source/$(notdir $@)

$(PKG_ARCH)/src/x13as/x13as: tarballs/x13as_asciisrc-v$(X13AS_VERSION).tar.gz
	rm -rf $(dir $@)
	mkdir -p $(dir $@)
	tar xf $< --directory $(dir $@) --strip-components=1
	# Statically link x13as (see #1865).
	# Using -static is not possible, it does not work under Darwin.
	cd $(dir $@) && sed -i '' 's/-static//g' makefile.gf
	gmake -C $(dir $@) -f makefile.gf FC=$(BREWDIR)/bin/gfortran LINKER=$(BREWDIR)/bin/gfortran FFLAGS="-O3 -std=legacy" LDFLAGS="-static-libgcc -static-libgfortran -static-libquadmath" PROGRAM=x13as -j$(NTHREADS)
	strip $@

#
# Panua PARDISO
#

$(PKG_ARCH)/panua-pardiso: tarballs/panua-pardiso-$(PANUA_PARDISO_VERSION)-mac_$(if $(filter x86_64,$(PKG_ARCH)),x86,arm64).zip
	rm -rf $@
	unzip -o $<
	mv $(basename $(notdir $<)) $@
	touch $@

#
# SuiteSparse
#

tarballs/SuiteSparse-$(SUITESPARSE_VERSION).tar.gz:
	wget $(WGET_OPTIONS) -O $@ https://github.com/DrTimothyAldenDavis/SuiteSparse/archive/refs/tags/v$(SUITESPARSE_VERSION).tar.gz

$(PKG_ARCH)/src/suitesparse: tarballs/SuiteSparse-$(SUITESPARSE_VERSION).tar.gz
	rm -rf $@
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

=== windows/deps/Makefile ===
# Copyright © 2017-2026 Dynare Team
#
# This file is part of Dynare.
#
# Dynare is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# Dynare is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with Dynare.  If not, see <https://www.gnu.org/licenses/>.

include versions.mk

ROOT_PATH = $(realpath .)

WGET_OPTIONS := --no-verbose --no-use-server-timestamps --retry-connrefused --retry-on-host-error

.PHONY: all clean clean-all

all: sysroot-matlab sysroot-octave gcc x13as src/suitesparse

# Clean everything except downloaded tarballs
clean:
	rm -rf src octave sysroot-matlab sysroot-octave gcc x13as panua-pardiso

# Clean everything (including downloaded tarballs)
clean-all: clean
	rm -rf tarballs

#
# Slicot
#

tarballs/slicot-$(SLICOT_VERSION).tar.gz:
	mkdir -p tarballs
	wget $(WGET_OPTIONS) -O $@ https://github.com/SLICOT/SLICOT-Reference/archive/refs/tags/v$(SLICOT_VERSION).tar.gz

src/slicot-matlab/build/lib/libslicot64.a: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf $(realpath $(dir $@)/../..)
	mkdir -p $(dir $@)/../..
	tar xf $< --directory $(dir $@)/../.. --strip-components=1
	patch -d $(dir $@)/../.. -p1 < slicot-no-blas-lapack-lookup.patch
	# NB: -fno-underscoring is passed in FFLAGS, and is prepended to CMAKE_Fortran_FLAGS_INIT from the toolchain file.
	# We don’t put it in that latter variable, so that the toolchain file can be shared with Octave.
	FFLAGS="-fno-underscoring" cmake -S $(dir $@)/../.. -B $(dir $@)/.. -DCMAKE_TOOLCHAIN_FILE=$(CURDIR)/toolchain-mingw64.cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=OFF -DSLICOT_TESTING=OFF -DSLICOT_INTEGER8=ON
	cmake --build $(dir $@)/.. --verbose

src/slicot-octave/build/lib/libslicot.a: tarballs/slicot-$(SLICOT_VERSION).tar.gz
	rm -rf $(realpath $(dir $@)/../..)
	mkdir -p $(dir $@)/../..
	tar xf $< --directory $(dir $@)/../.. --strip-components=1
	patch -d $(dir $@)/../.. -p1 < slicot-no-blas-lapack-lookup.patch
	cmake -S $(dir $@)/../.. -B $(dir $@)/.. -DCMAKE_TOOLCHAIN_FILE=$(CURDIR)/toolchain-mingw64.cmake -DCMAKE_BUILD_TYPE=Release -DBUILD_SHARED_LIBS=OFF -DSLICOT_TESTING=OFF -DSLICOT_INTEGER8=OFF
	cmake --build $(dir $@)/.. --verbose


#
# Octave
#

tarballs/octave-${OCTAVE_VERSION}${OCTAVE_W64_BUILD}-w64.7z:
	mkdir -p $(dir $@)
	wget $(WGET_OPTIONS) -O $@ https://ftpmirror.gnu.org/gnu/octave/windows/$(notdir $@)

octave: tarballs/octave-${OCTAVE_VERSION}${OCTAVE_W64_BUILD}-w64.7z
	rm -rf $@
	7zr x $< > /dev/null
	mv octave-${OCTAVE_VERSION}-w64 $@
	touch $@

#
# MATLAB
#

tarballs/matlab%.tar.xz:
	mkdir -p $(dir $@)
	wget $(WGET_OPTIONS) -O $@.gpg https://www.dynare.org/pkg-build/$(notdir $@).gpg
	gpg --output $@ --decrypt $@.gpg
	rm $@.gpg

#
# The three root directories:
# - for building MATLAB MEX
# - for builing Octave MEX
# - the embedded GCC compiler (for use_dll)
#

MSYS2_EXCLUDES := --exclude .MTREE --exclude .BUILDINFO --exclude .PKGINFO

tarballs/mingw-w64-ucrt-x86_64-%-any.pkg.tar.zst:
	mkdir -p $(dir $@)
	wget $(WGET_OPTIONS) -O $@ https://www.dynare.org/windows-pkg-build/msys2/7.x/$(notdir $@)

MATLAB_MSYS2_DEPS := \
	tarballs/mingw-w64-ucrt-x86_64-boost-$(MSYS2_BOOST_VERSION)-any.pkg.tar.zst

sysroot-matlab: tarballs/matlab64-$(MATLAB64_VERSION).tar.xz $(MATLAB_MSYS2_DEPS) src/slicot-matlab/build/lib/libslicot64.a panua-pardiso
	rm -rf $@
	mkdir $@
	for f in $(MATLAB_MSYS2_DEPS); do tar xf $$f --directory $@ $(MSYS2_EXCLUDES); done
	mkdir $@/MATLAB
	tar xf $< --directory $@/MATLAB/
	cp src/slicot-matlab/build/lib/libslicot64.a $@/ucrt64/lib/libslicot64_pic.a
	cp panua-pardiso/lib/libpardiso.dll $@/ucrt64/lib
	touch $@

OCTAVE_MSYS2_DEPS := \
	tarballs/mingw-w64-ucrt-x86_64-boost-$(MSYS2_BOOST_VERSION)-any.pkg.tar.zst

sysroot-octave: octave $(OCTAVE_MSYS2_DEPS) src/slicot-octave/build/lib/libslicot.a panua-pardiso
	rm -rf $@
	mkdir $@
	for f in $(OCTAVE_MSYS2_DEPS); do tar xf $$f --directory $@ $(MSYS2_EXCLUDES); done
	cp src/slicot-octave/build/lib/libslicot.a $@/ucrt64/lib/libslicot_pic.a
	cp -R octave/mingw64/include/octave-* octave/mingw64/include/suitesparse $@/ucrt64/include
	cp -R octave/mingw64/lib/octave $@/ucrt64/lib
	cp octave/mingw64/lib/libblas.dll.a octave/mingw64/lib/liblapack.dll.a octave/mingw64/lib/libumfpack.dll.a octave/mingw64/lib/libopenblas.dll.a $@/ucrt64/lib
	mkdir -p $@/ucrt64/lib/pkgconfig
	cp octave/mingw64/lib/pkgconfig/UMFPACK.pc octave/mingw64/lib/pkgconfig/AMD.pc octave/mingw64/lib/pkgconfig/SuiteSparse_config.pc octave/mingw64/lib/pkgconfig/openblas.pc $@/ucrt64/lib/pkgconfig
	cp panua-pardiso/lib/libpardiso.dll $@/ucrt64/lib
	patch -p0 < octave-pkgconfig.patch
	touch $@

GCC_MSYS2_DEPS := \
	tarballs/mingw-w64-ucrt-x86_64-gcc-$(MSYS2_GCC_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-gcc-libs-$(MSYS2_GCC_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-gmp-$(MSYS2_GMP_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-binutils-$(MSYS2_BINUTILS_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-headers-$(MSYS2_HEADERS_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-crt-$(MSYS2_CRT_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-winpthreads-$(MSYS2_WINPTHREADS_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-libwinpthread-$(MSYS2_WINPTHREADS_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-zlib-$(MSYS2_ZLIB_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-zstd-$(MSYS2_ZSTD_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-isl-$(MSYS2_ISL_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-mpc-$(MSYS2_MPC_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-mpfr-$(MSYS2_MPFR_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-libiconv-$(MSYS2_LIBICONV_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-windows-default-manifest-$(MSYS2_WINDOWS_DEFAULT_MANIFEST_VERSION)-any.pkg.tar.zst \
	tarballs/mingw-w64-ucrt-x86_64-gettext-runtime-$(MSYS2_GETTEXT_RUNTIME_VERSION)-any.pkg.tar.zst

gcc: $(GCC_MSYS2_DEPS)
	rm -rf $@
	mkdir $@
	for f in $(GCC_MSYS2_DEPS); do tar xf $$f --directory $@ $(MSYS2_EXCLUDES); done
	touch $@

#
# X13AS
#

tarballs/x13as_ascii-v$(X13AS_VERSION).zip:
	mkdir -p $(dir $@)
	wget $(WGET_OPTIONS) -O $@ https://www.dynare.org/pkg-build/x13as/windows/$(notdir $@)

x13as: tarballs/x13as_ascii-v$(X13AS_VERSION).zip
	rm -rf $@
	unzip -o $<
	mv $@/x13as_ascii.exe $@/x13as.exe
	touch $@

#
# Panua PARDISO
#

tarballs/panua-pardiso-%-win.zip:
	mkdir -p $(dir $@)
	wget $(WGET_OPTIONS) -O $@.gpg https://www.dynare.org/pkg-build/$(notdir $@).gpg
	gpg --output $@ --decrypt $@.gpg
	rm $@.gpg

panua-pardiso: tarballs/panua-pardiso-$(PANUA_PARDISO_VERSION)-win.zip
	rm -rf $@
	unzip -o $<
	mv $(basename $(notdir $<)) $@
	touch $@

#
# SuiteSparse
#

tarballs/SuiteSparse-$(SUITESPARSE_VERSION).tar.gz:
	wget $(WGET_OPTIONS) -O $@ https://github.com/DrTimothyAldenDavis/SuiteSparse/archive/refs/tags/v$(SUITESPARSE_VERSION).tar.gz

src/suitesparse: tarballs/SuiteSparse-$(SUITESPARSE_VERSION).tar.gz
	rm -rf $@
	mkdir -p $@
	tar xf $< --directory $@ --strip-components=1
	touch $@

=== debian/changelog ===
dynare (7~beta1-1) experimental; urgency=medium

  * New upstream version 7~beta1
  * d/copyright: reflect upstream changes
  * Remove libgsl-dev and libmatio-dev from (Build-)Depends
  * Add octave-datatypes to Recommends
  * Add python3-sphinxcontrib.bibtex to Build-Depends
  * Drop “Priority: optional”, which is now the default
  * Bump Standards-Version to 4.7.3

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 03 Mar 2026 17:05:42 +0100

=== debian/control ===
Source: dynare
Maintainer: Debian Octave Group <team+pkg-octave-team@tracker.debian.org>
Uploaders: Sébastien Villemot <sebastien@debian.org>
Section: math
Build-Depends: debhelper-compat (= 13),
               dh-elpa,
               dh-octave,
               gfortran,
               octave-dev,
               libboost-graph-dev,
               libslicot-dev,
               libsuitesparse-dev,
               flex,
               libfl-dev,
               bison,
               meson,
               pkgconf,
               tex-gyre,
               texlive,
               texlive-publishers,
               texlive-latex-extra,
               texlive-fonts-extra,
               texlive-science,
               texlive-plain-generic,
               lmodern,
               cm-super,
               python3-sphinx,
               python3-sphinxcontrib.bibtex,
               latexmk,
               libjs-mathjax
Standards-Version: 4.7.3
Vcs-Browser: https://salsa.debian.org/pkg-octave-team/dynare
Vcs-Git: https://salsa.debian.org/pkg-octave-team/dynare.git
Homepage: https://www.dynare.org/

Package: dynare
Architecture: any
Depends: ${octave:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         octave-statistics
Recommends: octave-dev,
            octave-optim,
            octave-io,
            octave-control,
            octave-datatypes
Suggests: dynare-doc,
          dynare-matlab,
          x13as
Breaks: dynare-common
Replaces: dynare-common
Description: platform for handling a wide class of economic models
 Dynare is a software platform for handling a wide class of economic models, in
 particular dynamic stochastic general equilibrium (DSGE) and overlapping
 generations (OLG) models. The models solved by Dynare include those relying on
 the rational expectations hypothesis, wherein agents form their expectations
 about the future in a way consistent with the model. But Dynare is also able
 to handle models where expectations are formed differently: on one extreme,
 models where agents perfectly anticipate the future; on the other extreme,
 models where agents have limited rationality or imperfect knowledge of the
 state of the economy and, hence, form their expectations through a learning
 process. In terms of types of agents, models solved by Dynare can incorporate
 consumers, productive firms, governments, monetary authorities, investors and
 financial intermediaries. Some degree of heterogeneity can be achieved by
 including several distinct classes of agents in each of the aforementioned
 agent categories.
 .
 Dynare offers a user-friendly and intuitive way of describing these models. It
 is able to perform simulations of the model given a calibration of the model
 parameters and is also able to estimate these parameters given a dataset. In
 practice, the user will write a text file containing the list of model
 variables, the dynamic equations linking these variables together, the
 computing tasks to be performed and the desired graphical or numerical
 outputs.
 .
 This package provides a full installation of Dynare, to be run on top of GNU
 Octave.

Package: dynare-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-mathjax
Multi-Arch: foreign
Description: documentation for Dynare
 Dynare is a software platform for handling a wide class of economic models, in
 particular dynamic stochastic general equilibrium (DSGE) and overlapping
 generations (OLG) models. The models solved by Dynare include those relying on
 the rational expectations hypothesis, wherein agents form their expectations
 about the future in a way consistent with the model. But Dynare is also able
 to handle models where expectations are formed differently: on one extreme,
 models where agents perfectly anticipate the future; on the other extreme,
 models where agents have limited rationality or imperfect knowledge of the
 state of the economy and, hence, form their expectations through a learning
 process. In terms of types of agents, models solved by Dynare can incorporate
 consumers, productive firms, governments, monetary authorities, investors and
 financial intermediaries. Some degree of heterogeneity can be achieved by
 including several distinct classes of agents in each of the aforementioned
 agent categories.
 .
 Dynare offers a user-friendly and intuitive way of describing these models. It
 is able to perform simulations of the model given a calibration of the model
 parameters and is also able to estimate these parameters given a dataset. In
 practice, the user will write a text file containing the list of model
 variables, the dynamic equations linking these variables together, the
 computing tasks to be performed and the desired graphical or numerical
 outputs.
 .
 This package contains full Dynare documentation, including the reference
 manual.

Package: dynare-matlab
Architecture: all
Section: contrib/math
Depends: ${misc:Depends},
         dynare (>= ${source:Version}),
         matlab-support,
         gcc,
         g++,
         gfortran,
         libboost-graph-dev,
         libslicot64-pic,
         libsuitesparse-dev,
         flex,
         libfl-dev,
         bison,
         meson,
         pkgconf
Description: MATLAB support for Dynare
 Dynare is a software platform for handling a wide class of economic models, in
 particular dynamic stochastic general equilibrium (DSGE) and overlapping
 generations (OLG) models. The models solved by Dynare include those relying on
 the rational expectations hypothesis, wherein agents form their expectations
 about the future in a way consistent with the model. But Dynare is also able
 to handle models where expectations are formed differently: on one extreme,
 models where agents perfectly anticipate the future; on the other extreme,
 models where agents have limited rationality or imperfect knowledge of the
 state of the economy and, hence, form their expectations through a learning
 process. In terms of types of agents, models solved by Dynare can incorporate
 consumers, productive firms, governments, monetary authorities, investors and
 financial intermediaries. Some degree of heterogeneity can be achieved by
 including several distinct classes of agents in each of the aforementioned
 agent categories.
 .
 Dynare offers a user-friendly and intuitive way of describing these models. It
 is able to perform simulations of the model given a calibration of the model
 parameters and is also able to estimate these parameters given a dataset. In
 practice, the user will write a text file containing the list of model
 variables, the dynamic equations linking these variables together, the
 computing tasks to be performed and the desired graphical or numerical
 outputs.
 .
 This package is only useful to users having MATLAB installed on their
 machine. It contains the source of the MEX files and will recompile them using
 the existing MATLAB installation.
